#include<p16f84a.inc>
;CONFIG	_XT_OSC & _WDT_OFF & _PWRTE_ON
;  HT1611  Pic16 + Led
;
CBI		EQU	H'3F';  
CBY		EQU	H'3E';  
CTO		EQU	H'3D';   
COU		EQU	H'3C';  
VOL		EQU	H'3B';   
BAL		EQU	H'3A';   
BAS		EQU	H'39';   
TRE		EQU	H'38';   
R0		EQU	H'30'
R1		EQU	H'31'; 
R2		EQU	H'32'
R3		EQU	H'33'
R4		EQU	H'34'
R5		EQU	H'35'
R6		EQU	H'36'; 
R7		EQU	H'37';
;
		ORG H'0'
RESET		GOTO	START
		ORG H'4'
;Interrupt  
		BCF	INTCON,GIE	;  
		BTFSC	INTCON,INTF		;     
		GOTO	CLKI
		BTFSC	INTCON,T0IF		;    
		GOTO	TOF
		RETFIE
START		BCF	STATUS,	IRP
		BCF	STATUS,	RP1
		BSF	STATUS,	RP0
		MOVLW	B'00010001'	;A0, A4 -  ; A1, A2, A3 - 
		MOVWF	TRISA
		MOVLW	B'10000000'	;B0 -  ; B1...B7 - 
		MOVWF	TRISB
		MOVLW	B'10110000'	;     
		MOVWF	INTCON		;,   
		BCF	STATUS,	RP0
LOOP		GOTO	LOOP
		RETURN
EXIT		BCF	INTCON,T0IF	;   
		BCF	INTCON,INTF	;    
		RETFIE				;  
TOF		MOVLW	VOL		;  
		SUBWF	CTO			;   
		BTFSC	STATUS,	Z	;
		DECF	CTO
		GOTO	EXIT
CLKI		BTFSC	PORTA,	H'0'		;
		GOTO	ONE
		BCF	R7,	H'0'		;
NULL		RLF	R7			;
		INCF	CBI			;
		SUBLW	CBI			;
		GOTO	EXIT
ONE		BSF	R7,	H'0'		;
		GOTO	EXIT
		END
